/* $Id: cdefs.h,v 1.1.1.1 2001/09/21 02:52:59 psyex Exp $ */

#ifndef	_CDEFS_H_
# define	_CDEFS_H_

# if defined(__cplusplus)
#	define	__BEGIN_DECLS	extern "C" {
#	define	__END_DECLS	};
# else
#	define	__BEGIN_DECLS
#	define	__END_DECLS
# endif
/*
 * The __CONCAT macro is used to concatenate parts of symbol names,
 * e.g. with "#define OLD(foo) __CONCAT(old,foo)", OLD(foo) produces
 * oldfoo. The __CONCAT macro is a bit tricky -- make sure you don't
 * put spaces in between its arguments.  __CONCAT can also concatenate
 * double-quoted strings produced by the __STRING macro, but this only
 * works with ANSI C.
 */
# if defined(__STDC__) || defined(__cplusplus)
#	define	__P(protos)	protos	/* full-blown ANSI C */
#	define	__CONCAT(x,y)	x ## y
#	define	__STRING(x)	#x
# else /* !(__STDC__ || __cplusplus) */
#	define	__P(protos)	()	/* traditional C preprocessor */
#	define	__CONCAT(x,y)	x/**/y
#	define	__STRING(x)	"x"
#	ifdef __GNUC__
#	 define	const		__const	/* GCC: ANSI C with -traditional */
#	 define	inline		__inline
#	 define	signed		__signed
#	 define	volatile	__volatile
#	else /* !__GNUC__ */
#	 define	const			/* delete ANSI C keywords */
#	 define	inline
#	 define	signed
#	 define	volatile
#	endif /* !__GNUC__ */
# endif /* !(__STDC__ || __cplusplus) */
/*
 * GCC has extensions for declaring functions as `pure' (always returns
 * the same value given the same inputs, i.e., has no external state
 * and no side effects) and `dead' (nonreturning).  These mainly affect
 * optimization and warnings.  Unfortunately, GCC complains if these
 * are used under strict ANSI mode (`gcc -ansi -pedantic'), hence we
 * need to define them only if compiling without this.
 */
# if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#	define __dead __volatile
#	define __pure __const
# else
#	define __dead
#	define __pure
# endif
#endif /* !_CDEFS_H_ */
