#ifndef LOCAL_RESOLV_H
#define LOCAL_RESOLV_H 1

/* $Id: resolv.h,v 1.1.1.1 2001/09/21 02:53:16 psyex Exp $ */

#ifndef	_PATH_RESCONF
#define _PATH_RESCONF        "/etc/resolv.conf"
#endif
/*
 * Global defines and variables for resolver stub.
 */
#define	MAXNS		3	/*
				 * max # name servers we'll track 
				 */
#define	MAXDFLSRCH	3	/*
				 * # default domain levels to try 
				 */
#define	MAXDNSRCH	6	/*
				 * max # domains in search path 
				 */
#define	LOCALDOMAINPARTS 2	/*
				 * min levels in name that is "local" 
				 */
#define MAXSERVICES	2	/*
				 * max # of services to search 
				 */

#define	RES_TIMEOUT	5	/*
				 * min. seconds between retries 
				 */

struct state {
   int         retrans;		/*
				 * retransmition time interval 
				 */
   int         retry;		/*
				 * number of times to retransmit 
				 */
   long        options;		/*
				 * option flags - see below. 
				 */
   int         nscount;		/*
				 * number of name servers 
				 */
   struct sockaddr_in nsaddr_list[MAXNS];	/*
						 * address of name
						 * * server 
						 */
#define	nsaddr	nsaddr_list[0]	/*
				 * for backward compatibility 
				 */
   unsigned short id;		/*
				 * current packet id 
				 */
   char        defdname[MAXDNAME];	/*
					 * default domain 
					 */
   char       *dnsrch[MAXDNSRCH + 1];	/*
					 * components of domain to
					 * * search 
					 */
   unsigned short order[MAXSERVICES + 1];	/*
						 * search service order 
						 */
};

#define RES_SERVICE_NONE	0
#define RES_SERVICE_BIND	1
#define RES_SERVICE_LOCAL	2
/*
 * Resolver options
 */
#define RES_INIT	0x0001	/*
				 * address initialized 
				 */
#define RES_DEBUG	0x0002	/*
				 * print debug messages 
				 */
#define RES_AAONLY	0x0004	/*
				 * authoritative answers only 
				 */
#define RES_USEVC	0x0008	/*
				 * use virtual circuit 
				 */
#define RES_PRIMARY	0x0010	/*
				 * query primary server only 
				 */
#define RES_IGNTC	0x0020	/*
				 * ignore trucation errors 
				 */
#define RES_RECURSE	0x0040	/*
				 * recursion desired 
				 */
#define RES_DEFNAMES	0x0080	/*
				 * use default domain name 
				 */
#define RES_STAYOPEN	0x0100	/*
				 * Keep TCP socket open 
				 */
#define RES_DNSRCH	0x0200	/*
				 * search up local domain tree 
				 */

#define RES_DEFAULT	(RES_RECURSE | RES_DEFNAMES | RES_DNSRCH)

extern struct state _res;
extern char *p_cdname(), *p_rr(), *p_type(), *p_class(), *p_time();
# ifdef WIN32
extern int        dn_comp(u_char *exp_dn, u_char *comp_dn, int length, u_char **dnptrs, u_char **lastdnptr);
extern void       putshort(u_short s, u_char *msgp);
extern void       putlong(u_long l, u_char *msgp);
# endif
#if ((__GNU_LIBRARY__ == 6) && (__GLIBC__ >=2) && (__GLIBC_MINOR__ >= 2))
#define res_init __res_init
#endif

extern int  res_init();
#endif
