#!/bin/sh
spitshell=cat
package=IRC

echo "Extracting $package/src/version.c..."

if test -r version.c.last
then
	generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c.last`
if test ! "$generation" ; then generation=0; fi
else
	generation=0
fi

generation=`expr $generation + 1`

uname=`uname -a`
processor=`uname -m`
kernel=`uname -r`
os=`uname -s`

creation=`date | \
awk '{if (NF == 6) \
{ print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
{ print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell >version.c <<!SUB!THIS!
/* $Id: version.c.SH,v 1.1.1.1 2001/09/21 02:52:56 psyex Exp $ */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "patchlevel.h"

char *generation = "$generation";
char *creation = "$creation";
char version[128];
char *machine = "$processor";
char *kernel = "$kernel";
char *os = "$os";

char *infotext[] =
    {
	 "$package --",
	 "Based on the original code written by Jarkko Oikarinen",
	 "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
	 "",
	 "This program is free software; you can redistribute it and/or",
	 "modify it under the terms of the GNU General Public License as",
	 "published by the Free Software Foundation; either version 1, or",
	 "(at your option) any later version.",
	 "",
	 "Send bug reports to coders@myirc.net",
         "",
         "The following people have contributed code, or support",
         "to the Echelon team:",
         "Frostilicus         Kevin Orton         frosty@myirc.net",
         "PsyeX               Nathan Le Nevez     psyex@myirc.net",
	 "",
	 "",
	 "The following people have contributed code, or support",
	 "to the bahamut team (our IRCd base):",
	 "aClient             Diane Bruce         db@koruna.varner.com",
	 "Dakal               David Knepper       dakal@dal.net",
	 "Dalvenjah           Sven Nielsen        dalvenjah@dal.net",
	 "Epiphani            Aaron Wiebe         epiphani@dal.net",
	 "lucas               Lucas Madar         lucas@negaverse.org",
	 "MSofty              Mark Salerno        msofty@dal.net",
	 "Raistlin_Mejere     Jason Slagle        raistlin@bahamut.net",
	 "Rakarra             Ian Westcott        rakarra@dal.net",
	 "sedition            David Parton        sedition@dal.net",
	 "White_Dragon        Chip Norkus         wd@dal.net",
	 "",
	 "The following people have contributed ideas or testing to the",
	 "bahamut project:",
	 "driz                David Friedman      driz@dal.net",
	 "habit               Melinda Thompson    habit@dal.net",
	 "Kevin               Kevin Turner        kevin@dal.net",
	 "",
	 "",
	 "Thanks also goes to those persons not mentioned here who have added",
	 "their advice, opinions, and code to IRC.",
	 "Thanks also to those who provide the kind sys admins who let me and",
	 "others continue to develop IRC.",
	 "Thanks also to those who continue to make twinkies and doritos, as they",
	 "are the backbone of most programmers' diets and thus make it possible",
	 "for code like this to be developed!",
    "",
	 0,
};
!SUB!THIS!
